Siddhi Complex Event Processing Engine 
======================================

Siddhi CEP is a lightweight, easy-to-use Open Source Complex Event Processing Engine (CEP) released as a Java Library under Apache Software License v2.0. Siddhi CEP process events generated by various event sources, analyze them and notifies appropriate complex events according to the user specified queries.

This project was initiated as a research project at University of Moratuwa, Sri Lanka, and now being improved by [WSO2 Inc](http://wso2.com/). 

**Active development version of Siddhi** : **v4.0.0**  _built on Java 8._


|  Siddhi Branch | Jenkins Build Status |
| :---------------------------------------- |:---------------------------------------
| master         | [![Build Status](https://wso2.org/jenkins/view/wso2-dependencies/job/siddhi/job/siddhi/badge/icon)](https://wso2.org/jenkins/view/wso2-dependencies/job/siddhi/job/siddhi )|


### Documentation 
Siddhi Query Guide: [https://wso2.github.io/siddhi/documentation/siddhi-4.0/](https://wso2.github.io/siddhi/documentation/siddhi-4.0/) 

Siddhi Extensions:  [https://github.com/wso2-extensions?q=siddhi](https://github.com/wso2-extensions?q=siddhi) 


### Siddhi Releases 
**Latest Stable Release : v3.0.5**

List of Siddhi releases : [https://github.com/wso2/siddhi/releases](https://github.com/wso2/siddhi/releases)

### Try Siddhi
Can find latest Siddhi with it's debugger feature at **[WSO2 Stream Processor](https://github.com/wso2/product-sp/releases)** 

**Try latest Stable Siddhi with [WSO2 Data Analytics Server 3.1](http://wso2.com/analytics)** [try-it tool](https://docs.wso2.com/display/DAS310/Siddhi+Try+It+Tool)

Siddhi is also used with [WSO2 IoT Server](http://wso2.com/iot) for IoT analytics and as an edge analytics library.

##Features Supported

 - Filter
    - Multiple filter conditions can be defined 
    - Filters can be applied before and/or after Window operations
 - Join
    - Supports joining two streams into one based on a condition   
    - Match operation triggering can be configured (making "left" or "right" or both streams to trigger)
    - Supports Left, Right & Full Outer Joins and Inner Join
 - Aggregation
    - By default shipped with Avg, Sum, Min, Max, etc
    - Supports Custom Aggregations via its pluggable architecture
 - Group by
    - Supports Group by based on more than one attribute
    - Supported for all type of queries
 - Having
    - Supported for all type of queries
 - Window
    - Default implementations to Windows are: Time Window, Time Batch Window, Length Window, Unique Window, etc
    - Supports Window operators via the pluggable architecture
 - Conditions and Expressions
    - Supporting condition and expression evaluation
    - Conditions supported are: and, or, not, ==,!=, >=, >, <=, <, and arithmetic operations
    - Attributes supported are: boolean, string, int, long, float, double, object
    - Expressions can be implemented as extensions via Siddhi's pluggable architecture
 - Pattern processing
    - Identifies pattern occurrences within streams
    - Supports "every" condition
    - Can temporally process any amount of events from streams with followed by (->) operation
    - Can process two streams at the same time via "and" and "or" conditions
    - Can collect multiple events, with min and max limit, using "count" condition
 - Sequence processing
    - Identifies continuous sequence of events from streams
    - Can process two streams at the same time using "or" conditions on streams 
    - Supports zero to many, one to many, and zero to one condition
 - Event Tables
    - Support for using historical data in real-time processing
    - Can process with the in-memory, RDBMS or Hazelcast(In-memory data grid) based data collection
 - Partitions
    - Supports query partitions based on keywords and value ranges 
    - Multiple queries can be grouped within a partition
 - Scripting 
    - Support JavaScript & Scala Scripts within Siddhi Queries
 - Query Language
    - SQL-like query language 
    - Implemented on Antlr4
    - Supports Query, Stream Definition, and Query Plan compilation

## System Requirements
1. Minimum memory - 500 MB (based on in-memory data stored for processing)
2. Processor      - Pentium 800MHz or equivalent at minimum
3. Java SE Development Kit 1.8 (1.7 for 3.x version)
4. To build Siddhi CEP from the Source distribution, it is necessary that you have
   JDK 1.8 version (1.7 for 3.x version) or later and Maven 3.0.4 or later

## Questions 
* Questions are welcomed & we are happy to help you integrate Siddhi to your project :)
* Post your questions on http://stackoverflow.com/ tagging ["siddhi"](http://stackoverflow.com/search?q=siddhi)

## How to Contribute
* Please report issues at [Siddhi Github Issue Tacker](https://github.com/wso2/siddhi/issues)
* Send your bug fixes and pull requests to [Siddhi Master Branch](https://github.com/wso2/siddhi) 

## Contact us 
Siddhi developers can be contacted via the mailing lists:

* Carbon Developers List: dev@wso2.org
* Carbon Architecture List: architecture@wso2.org

## Support 
Siddhi is supported by [WSO2](http://wso2.com/) by the very same engineers who build the technology. We are committed to ensuring that your deployment is completely supported from evaluation to production.
For more details please contact us by visiting [http://wso2.com/support](http://wso2.com/support).
